Magellan Linux

Contents of /alx-src/trunk/alxinstall-ng/bin/alxinstall-ng.sh.in

Parent Directory Parent Directory | Revision Log Revision Log


Revision 6837 - (show annotations) (download)
Thu Jul 23 12:49:52 2015 UTC (8 years, 9 months ago) by niro
File size: 23402 byte(s)
-added rudimantary f2fs support
1 #!/bin/sh
2 # $Id$
3
4 # ignore environment!
5 LC_ALL=C
6
7 MLIBDIR="/usr/lib/alxinstall-ng"
8
9 # images: (get ${CDIMAGENAME})
10 source /mnt/cdrom/system/images.conf
11
12 # includes
13 source ${MLIBDIR}/functions/generic.sh
14 source ${MLIBDIR}/functions/hwdetection.sh
15
16 ### System/Config Version
17 VERSION="@@VERSION@@"
18 TITLE="alxinstall-ng - ${VERSION}"
19
20 # locations
21 CDPATH="/mnt/cdrom"
22 INSTALL_ROOT="/mnt/magellan"
23
24 # default system settings
25 # standard kernel opts
26 DEFAULT_KERNELOPTS="quiet video=1024x768"
27
28 # grub options
29 DEFAULT_GRUBLEGACYOPTS=""
30 DEFAULT_GRUB2OPTS=""
31 DEFAULT_GRUB2GFXPAYLOAD="1024x768x16,1024x768"
32
33 # default specialdevices
34 DEFAULT_FORMFACTOR="desktop"
35
36 # target filesystem
37 DEFAULT_FORMAT_FILESYSTEM="ext4"
38
39 # initialize global variables so they are exportable
40 INSTALL_METHOD=""
41 KERNELOPTS=""
42 GRUBLEGACYOPTS=""
43 GRUB2OPTS=""
44 GRUB2GFXPAYLOAD=""
45 FORMFACTOR=""
46 FORMAT_FILESYSTEM=""
47 FDISKPARTIONBELOW256MB=0
48 SPECIALDEVICE=""
49 FLASHDISK=0
50 ### linecount of system.tar.gz -1 !
51 CURRENTLINE=0
52 #TOTALLINES=11072 # -> now in images.conf
53
54 #################################################
55 # DIALOG BOXES #
56 #################################################
57
58 die()
59 {
60 ERROR=$1
61 RETVAL=$?
62 dialog_install_failure
63 trap_exit
64 exit 1
65 }
66
67 dialog_warning()
68 {
69 dialog \
70 --backtitle "${TITLE}" \
71 --colors \
72 --defaultno \
73 --yesno "\Z1 !!! Achtung !!! \Zn\n\n\
74 Diese Festplatte wird unwiederruflich geloescht werden.\n\n\
75 Soll ich wirklich fortfahren ?" 10 70
76 RES=$?
77 if [[ ${RES} -eq 1 ]]
78 then
79 clear
80 echo "Der Vorgang wurde abgebrochen."
81 exit 1
82 fi
83 }
84
85 dialog_setup_hdd_info()
86 {
87 case "${INSTALL_METHOD}" in
88 auto)
89 dialog_setup_hdd_info_auto
90 dialog_setup_hdd_create_partitions
91 ;;
92 normal) dialog_setup_hdd_info_normal ;;
93 single) dialog_setup_hdd_info_single ;;
94 flash) dialog_setup_hdd_info_flash ;;
95 esac
96 }
97
98 dialog_setup_hdd_info_normal()
99 {
100 local SHDD="$(echo ${HDD} | sed 's/\/dev\///')"
101
102 dialog \
103 --colors \
104 --title "[ Festplatten Partitionierung ]" \
105 --backtitle "${TITLE}" \
106 --ok-label "Weiter" \
107 --msgbox "\nBitte legen Sie 3 Partitionen an.\n\n\
108 [ \Z3${SHDD}1\Zn ] Typ: \Z3Linux\Zn mit ca. 50MB\n\
109 [ \Z3${SHDD}2\Zn ] Typ: \Z3Linux Swap\Zn mit ca. 256MB\n\
110 [ \Z3${SHDD}3\Zn ] Typ: \Z3Linux \Zn mit dem Rest (min. 256MB)\n\n\
111 Bitte ${SHDD}1 als \Z3bootable\Zn markieren." 12 81
112 }
113
114 dialog_setup_hdd_info_single()
115 {
116 local SHDD="$(echo $HDD | sed 's/\/dev\///')"
117
118 dialog \
119 --colors \
120 --title "[ Festplatten Partitionierung ]" \
121 --backtitle "${TITLE}" \
122 --ok-label "Weiter" \
123 --msgbox "\nBitte legen Sie 1 Partition an.\n\n\
124 [ \Z3${SHDD}1\Zn ] Typ: \Z3Linux\Zn mit dem gesamten Speicher\n\
125 Bitte ${SHDD}1 als \Z3bootable\Zn markieren." 12 81
126 }
127
128 dialog_setup_hdd_info_flash()
129 {
130 local SHDD="$(echo ${HDD} | sed 's/\/dev\///')"
131
132 dialog \
133 --colors \
134 --title "[ Festplatten Partitionierung ]" \
135 --backtitle "${TITLE}" \
136 --ok-label "Weiter" \
137 --msgbox "\nBitte legen Sie 2 Partitionen an.\n\n\
138 [ \Z3${SHDD}1\Zn ] Typ: \Z3Linux\Zn mit ca. 50MB\n\
139 [ \Z3${SHDD}2\Zn ] Typ: \Z3Linux \Zn mit dem Rest (min. 256MB)\n\n\
140 Bitte ${SHDD}1 als \Z3bootable\Zn markieren." 12 81
141 }
142
143 dialog_setup_hdd_info_auto()
144 {
145 local SHDD="$(echo $HDD | sed 's/\/dev\///')"
146
147 dialog \
148 --colors \
149 --title "[ Festplatten Partitionierung ]" \
150 --backtitle "${TITLE}" \
151 --ok-label "Weiter" \
152 --msgbox "\nAchtung!\n\
153 Alle Daten werden von der Disk [ \Z3${HDD}\Zn ] gelöscht!" 12 81
154 }
155
156 dialog_setup_system_menu()
157 {
158 local i
159
160 i=$(dialog \
161 --backtitle "${TITLE}" \
162 --title "[ Festplatten Partitionierung ]" \
163 --cancel-label "Abbrechen" \
164 --ok-label "Weiter" \
165 --stdout \
166 --colors \
167 --menu "\nWaehlen Sie die Installations-Methode" 14 70 5 \
168 "1" "Automatisches Setup (Empfohlen)" \
169 "" "" \
170 "" "\Z1Experten Modi:\Zn" \
171 "2" "Normale IDE-Disk (Manuell)" \
172 "3" "Normale IDE Disk (Single)" \
173 "4" "Flash SDHC/NAND oder USBStick (Manuell)")
174 RES=$?
175 [[ ${RES} -eq 1 ]] && return 1
176 if [[ ${RES} -eq 0 ]]
177 then
178 case "${i}" in
179 "1") run_install auto ;;
180 "2") run_install normal ;;
181 "3") run_install single ;;
182 "3") run_install flash ;;
183 "") dialog_setup_system_menu;;
184 esac
185 fi
186 }
187
188 dialog_hardware_detection()
189 {
190 local i
191 local hwtmp
192
193 if [ -x $(which mktemp &> /dev/null) ]
194 then
195 hwtmp="$(mktemp)"
196 else
197 hwtmp="/tmp/hwtmp.sh"
198 fi
199
200 run_hardware_detection_disks
201
202 echo "dialog \\" > ${hwtmp}
203 echo "--backtitle \"${TITLE}\" \\" >> ${hwtmp}
204 echo "--ok-label \"Weiter\" \\" >> ${hwtmp}
205 echo "--stdout \\" >> ${hwtmp}
206 echo "--colors \\" >> ${hwtmp}
207 echo "--msgbox \"Gefundene Hardware:\n\n \\" >> ${hwtmp}
208 echo " Festplatten:\n \\" >> ${hwtmp}
209
210 if [[ ! -z ${ALL_DISKS} ]]
211 then
212 for i in ${ALL_DISKS}
213 do
214 echo " \\Z3${i}\\Zn\n \\" >> ${hwtmp}
215 done
216 fi
217
218 if [[ ! -z ${ALL_CDROMS} ]]
219 then
220 echo " \n \\" >> ${hwtmp}
221 echo " CDROM Laufwerke:\n \\" >> ${hwtmp}
222 for i in ${ALL_CDROMS}
223 do
224 echo " \\Z3${i}\\Zn\n \\" >> ${hwtmp}
225 done
226 fi
227
228 # other devices
229 run_hardware_detection
230 case "${SPECIALDEVICE}" in
231 zotac*) echo " \n \\Z2Zotac Device erkannt.\\Zn \\" >> ${hwtmp} ;;
232 rangee) echo " \n \\Z2Rangee Device erkannt.\\Zn \\" >> ${hwtmp} ;;
233 maxdata) echo " \n \\Z2Maxdata Device erkannt.\\Zn \\" >> ${hwtmp} ;;
234 i845) echo " \n \\Z2Intel i845 Device erkannt.\\Zn \\" >> ${hwtmp} ;;
235 *) echo " \n \\ZnStandard Device erkannt.\\Zn \\" >> ${hwtmp} ;;
236 esac
237 if [[ ${FORMFACTOR} = laptop ]]
238 then
239 echo " \n \\ZnFormfactor Laptop, Powersave Modus 'ondemand' wird aktiviert.\\Zn \\" >> ${hwtmp}
240 fi
241 if [[ ${FLASHDISK} = 1 ]]
242 then
243 echo " \n \\ZnFlash Speicher erkannt, F2FS wird als Dateisystem benutzt.\\Zn \\" >> ${hwtmp}
244 fi
245
246 echo " \" 14 70" >> ${hwtmp}
247 chmod a+x ${hwtmp}
248 ${hwtmp}
249
250 # remove tmp file
251 if [[ -f ${hwtmp} ]]
252 then
253 rm ${hwtmp}
254 fi
255 }
256
257 dialog_setup_hdd_partitions()
258 {
259 local i
260
261 if [[ -z ${ALL_DISKS} ]]
262 then
263 dialog \
264 --backtitle "${TITLE}" \
265 --ok-label "Beenden" \
266 --msgbox "Kein geeignetes Laufwerk gefunden.\nDie Installation ist fehlgeschlagen." 6 70
267 exit 1
268 else
269
270 echo "dialog \\" > /tmp/hddtmp.sh
271 echo "--backtitle \"${TITLE}\" \\" >> /tmp/hddtmp.sh
272 echo "--ok-label \"Weiter\" \\" >> /tmp/hddtmp.sh
273 echo "--cancel-label \"Beenden\" \\" >> /tmp/hddtmp.sh
274 echo "--stdout \\" >> /tmp/hddtmp.sh
275 echo "--menu \"Installations Laufwerk auswaehlen:\" 10 70 3 \\" >> /tmp/hddtmp.sh
276
277 for i in ${ALL_DISKS}
278 do
279 echo "\"${i}\" \"\" \\" >> /tmp/hddtmp.sh
280 done
281 echo -e "\n" >> /tmp/hddtmp.sh
282
283 chmod a+x /tmp/hddtmp.sh
284 HDD="$(/tmp/hddtmp.sh)"
285 RES=$?
286 [[ ${RES} -eq 1 ]] && return 1
287 if [[ ${RES} -eq 0 ]]
288 then
289 dialog_setup_hdd_info
290 setup_hdd_partitions
291 fi
292 fi
293 }
294
295 dialog_setup_hdd_create_partitions()
296 {
297 dialog \
298 --backtitle "${TITLE}" \
299 --infobox "Erstelle Disk Partitionen ..." 3 70
300 }
301
302 dialog_setup_hdd_format()
303 {
304 dialog \
305 --backtitle "${TITLE}" \
306 --infobox "Erstelle Datei-Systeme ..." 3 70
307 }
308
309 dialog_install_settings()
310 {
311 dialog \
312 --backtitle "${TITLE}" \
313 --infobox "Speichere System-Einstellungen ..." 3 70
314 }
315
316 dialog_install_system_image()
317 {
318 dialog \
319 --backtitle "${TITLE}" \
320 --gauge "Kopiere System-Image ..." 6 80
321 }
322
323 dialog_install_meter()
324 {
325 while [[ ${CURRENTLINE} != ${TOTALLINES} ]]
326 do
327 CURRENTLINE=$(grep -c . /tmp/install.log)
328 PERCENT=$(( ${CURRENTLINE} * 100 / ${TOTALLINES}))
329 echo ${PERCENT}
330 sleep 1
331 done
332 rm -f /tmp/install.log
333 return 0
334 }
335
336 dialog_install_bootsector()
337 {
338 dialog \
339 --backtitle "${TITLE}" \
340 --infobox "Schreibe den Bootsektor ..." 3 70
341 }
342
343 dialog_install_successful()
344 {
345 dialog \
346 --backtitle "${TITLE}" \
347 --colors \
348 --msgbox "Die Installation war \Z2erfolgreich\Zn." 5 81
349 }
350
351 dialog_install_failure()
352 {
353 dialog \
354 --backtitle "${TITLE}" \
355 --colors \
356 --msgbox "Die Installation ist \Z1Fehlgeschlagen\Zn.\n\n\
357 Fehler bei ${ERROR}, RetVal: ${RETVAL} \
358 " 10 81
359 }
360
361 dialog_main()
362 {
363 METHOD=0
364
365 while [[ ${METHOD} -le 2 ]]
366 do
367 METHOD=$(dialog \
368 --backtitle "${TITLE}" \
369 --no-cancel \
370 --ok-label "Weiter" \
371 --stdout \
372 --menu "Konfiguration" 14 70 5 \
373 "1" "AutoSta_LX installieren" \
374 "2" "Uebersicht gefundener Laufwerke" \
375 "3" "Beenden und neustarten" \
376 "4" "Beenden und eine Shell starten")
377 RES=$?
378 [[ ${RES} -eq 1 ]] && exit 1
379 if [[ ${RES} -eq 0 ]]
380 then
381 case ${METHOD} in
382 "1") dialog_setup_system_menu ;;
383 "2") dialog_hardware_detection ;;
384 "3") install_do_reboot ;;
385 "4") /bin/bash --login -i ;;
386 esac
387 fi
388 done
389 }
390
391 #################################################
392 # Install Commands #
393 #################################################
394 run_hardware_detection()
395 {
396 local hwinfo
397 hwinfo="$(hwinfo --bios --storage --pci --gfxcard --sys)"
398
399 # check for special devices/clients:
400 # if zotac a zotac and the disk is a removeable device, then add rootdelay to kernelcmd
401 local removable=0
402 if [[ ! -z $(echo "${hwinfo}" | grep -i zotac) ]]
403 then
404 for i in /sys/block/[hs]d*/removable
405 do
406 if [[ $(< ${i}) = 1 ]]
407 then
408 removable=1
409 # we assume that all removable disks are flash disks
410 export FLASHDISK=1
411 fi
412 done
413
414 # only add this for grub legacy, grub2 detect these settings on its own
415 export GRUBLEGACYOPTS="rootdelay=8"
416 # there are two zotac types in the wild, nvidia based gfx and intel
417 if [[ ! -z $(echo "${hwinfo}" | grep -i nouveau) ]]
418 then
419 export SPECIALDEVICE="zotac_nvidia"
420 else
421 export SPECIALDEVICE="zotac_intel"
422 fi
423 fi
424
425 # check for special devices/clients:
426 # if a rangee and disk ist smaller then 256mb move partion one block further ahead
427 if [[ ! -z $(echo "${hwinfo}" | grep -i CLE266) ]]
428 then
429 # for a rangee always define partion startblock +1
430 export FDISKPARTIONBELOW256MB="1"
431 export SPECIALDEVICE="rangee"
432 export GRUBLEGACYOPTS=""
433 fi
434
435 # check for special devices/clients:
436 # check for maxdata / i810/ i815 Chipsets and disable KMS and use i810fb frambuffer
437 if [[ ! -z $(echo "${hwinfo}" | grep -i i810) ]] || [[ ! -z $(echo "${hwinfo}" | grep -i i815) ]]
438 then
439 export SPECIALDEVICE="maxdata"
440 export GRUBLEGACYOPTS=""
441 fi
442
443 # check for i845 Chipsets and disable KMS and use 915 drm driver
444 if [[ ! -z $(echo "${hwinfo}" | grep -i i845) ]]
445 then
446 export SPECIALDEVICE="i845"
447 # unset default video=1024x768 opt or the drm driver breaks
448 export KERNELOPTS="quiet"
449 export GRUBLEGACYOPTS=""
450 # enable full kms support
451 export GRUB2GFXPAYLOAD="keep"
452 fi
453
454 # check for radeon gfxcards
455 if [[ ! -z $(echo "${hwinfo}" | grep -i radeon) ]]
456 then
457 # enable full kms support
458 export GRUB2GFXPAYLOAD="keep"
459 fi
460
461 # check for special devices/clients:
462 # check for laptops and activate cpufreq scaling
463 if [[ $(echo "${hwinfo}" | grep 'Formfactor:' | sed 's:.*Formfactor\:\ \"\(.*\)\":\1:') = laptop ]]
464 then
465 export FORMFACTOR="laptop"
466 export KERNELOPTS="${KERNELOPTS} cpufreq.governor=ondemand"
467 fi
468 }
469
470 run_hardware_detection_disks()
471 {
472 local bootdev
473
474 # all disks but exclude ramdisks
475 export ALL_DISKS=$(get_hwinfo disk | sed '/\/dev\/ram[0-9].*/d')
476 # remove the boot device from ALL_DISKS if it was an usbstick
477 if [[ $(grep '[[:space:]]/mnt/cdrom[[:space:]]' /proc/mounts | cut -d' ' -f3) != iso9660 ]]
478 then
479 bootdev="$(grep '[[:space:]]/mnt/cdrom[[:space:]]' /proc/mounts | cut -d' ' -f1 | sed 's:[0-9]::g')"
480 export ALL_DISKS=$(echo "${ALL_DISKS}" | grep -v "${bootdev}")
481 fi
482 export ALL_CDROMS="$(get_hwinfo cdrom)"
483 }
484
485 hdd_size_below_256mb()
486 {
487 local hdd="$1"
488 local size
489 local retval
490 [[ -z ${hdd} ]] && die "Error: get_hdd_size() no \$hdd given!"
491
492 size=$(fdisk -l ${hdd} | grep "Disk.*${hdd}" | sed 's:.*,\ \(.*\)\ byte.*:\1:')
493 if [[ ${size} -le 257000000 ]]
494 then
495 retval="0"
496 else
497 retval="1"
498 fi
499
500 return "${retval}"
501 }
502
503 setup_hdd_partitions()
504 {
505 case "${INSTALL_METHOD}" in
506 normal)
507 BOOTHDD="${HDD}1"
508 SWAPHDD="${HDD}2"
509 ROOTHDD="${HDD}3"
510 ;;
511
512 single|auto)
513 BOOTHDD=""
514 SWAPHDD=""
515 ROOTHDD="${HDD}1"
516 ;;
517
518 flash)
519 BOOTHDD="${HDD}1"
520 SWAPHDD=""
521 ROOTHDD="${HDD}2"
522 ;;
523 esac
524
525 if [[ ${INSTALL_METHOD} = auto ]]
526 then
527 # run this only if FDISKPARTITIONBELOW256MB is not already 1
528 if [[ ${FDISKPARTIONBELOW256MB} != 1 ]]
529 then
530 if hdd_size_below_256mb ${HDD}
531 then
532 FDISKPARTIONBELOW256MB=1
533 else
534 FDISKPARTIONBELOW256MB=0
535 fi
536 fi
537
538 ## delete disk
539 dd if=/dev/zero of=${HDD} count=1 &> /dev/null || die
540
541 if [[ ${FDISKPARTIONBELOW256MB} = 1 ]]
542 then
543 ## setup one bootable partition
544 #1. n= new disk
545 #2. p= primary disk
546 #3. 1= first partition
547 #4. 2= default sector start // small disk needs more space for grub2 mbr sector
548 #5. ''= defaul sector end
549 #6. a= bootable flag
550 #7. 1= boot flag for partition 1
551 #8. w= write/quit
552 fdisk ${HDD} &> /dev/null << EOF
553 n
554 p
555 1
556 2
557
558 a
559 1
560 w
561 EOF
562 else
563 ## setup one bootable partition
564 #1. n= new disk
565 #2. p= primary disk
566 #3. 1= first partition
567 #4. ''= default sector start
568 #5. ''= defaul sector end
569 #6. a= bootable flag
570 #7. 1= boot flag for partition 1
571 #8. w= write/quit
572 fdisk ${HDD} &> /dev/null << EOF
573 n
574 p
575 1
576
577
578 a
579 1
580 w
581 EOF
582 fi
583 else
584 ## hdds partitionieren manuell
585 cfdisk ${HDD} || die
586 fi
587 }
588
589 setup_hdd_format()
590 {
591 if [[ -n ${SWAPHDD} ]]
592 then
593 mkswap ${SWAPHDD} || die
594 fi
595 if [[ -n ${BOOTHDD} ]]
596 then
597 # f2fs is not grub/grub2 compatible
598 if [[ ${FORMAT_FILESYSTEM} = f2fs ]]
599 then
600 mkfs.ext2 -q ${BOOTHDD} || die
601 else
602 mkfs.${FORMAT_FILESYSTEM} -q ${BOOTHDD} || die
603 fi
604 fi
605 if [[ -n ${ROOTHDD} ]]
606 then
607 mkfs.${FORMAT_FILESYSTEM} -q ${ROOTHDD} || die
608 fi
609 }
610
611 install_mount_rootfs()
612 {
613 local opts
614
615 if [[ -n ${SWAPHDD} ]]
616 then
617 swapon ${SWAPHDD} || die
618 fi
619 if [[ -n ${ROOTHDD} ]]
620 then
621 # be safe here, append file system type to mount
622 # just in case the f2fs module was not autoloaded
623 [[ ${FORMAT_FILESYSTEM} = f2fs ]] && opts="-t fs2fs"
624 mount ${opts} ${ROOTHDD} ${INSTALL_ROOT} || die
625 fi
626 if [[ -n ${BOOTHDD} ]]
627 then
628 install -d ${INSTALL_ROOT}/boot || die
629 mount ${BOOTHDD} ${INSTALL_ROOT}/boot || die
630 fi
631
632 cd ${INSTALL_ROOT} || die
633 }
634
635 install_system_image()
636 {
637 tar xvjpf ${CDPATH}/system/${CDIMAGENAME} -C ${INSTALL_ROOT}
638 }
639
640 install_bootsector_chroot()
641 {
642 local my_roothdd
643 local grubconf=${INSTALL_ROOT}/boot/grub/grub.conf
644 local grub2conf=/boot/grub/grub.cfg
645 local CONFIG
646
647 # check for grub2
648 if [[ -f ${INSTALL_ROOT}/sbin/grub-mkconfig ]]
649 then
650 # needed by grub-mkconfig on the first run
651 if [[ ! -f ${INSTALL_ROOT}/boot/grub/video.lst ]]
652 then
653 install -m0644 ${INSTALL_ROOT}/lib/grub/*/video.lst ${INSTALL_ROOT}/boot/grub/video.lst || die
654 fi
655
656 # set kernelopts
657 if [[ -f ${INSTALL_ROOT}/etc/conf.d/grub ]]
658 then
659 sed -i "s:^\(export GRUB_CMDLINE_LINUX_DEFAULT=\).*:\1\"${KERNELOPTS}\":" ${INSTALL_ROOT}/etc/conf.d/grub || die
660 sed -i "s:^\(export GRUB_GFXPAYLOAD_LINUX=\).*:\1\"${GRUB2GFXPAYLOAD}\":" ${INSTALL_ROOT}/etc/conf.d/grub || die
661 else
662 echo "export GRUB_CMDLINE_LINUX_DEFAULT=\"${KERNELOPTS}\"" > ${INSTALL_ROOT}/etc/conf.d/grub || die
663 echo "export GRUB_GFXPAYLOAD_LINUX=\"${GRUB2GFXPAYLOAD}\"" >> ${INSTALL_ROOT}/etc/conf.d/grub || die
664 fi
665 CONFIG=${INSTALL_ROOT}/.installrc
666 clearconfig
667 addconfig 'grub-mkdevicemap'
668 addconfig "LC_ALL=C grub-mkconfig -o ${grub2conf} &> /dev/null"
669 addconfig "grub-install --no-floppy ${HDD} &> /dev/null"
670 addconfig "exit 0"
671
672 # grub-legacy
673 else
674 ### grubconf schreiben
675 source ${INSTALL_ROOT}/boot/kernelversion
676
677 #for alx only
678 if [ -e ${INSTALL_ROOT}/etc/alx_version ]
679 then
680 OLD_ALXVER="${ALXVER}"
681 source ${INSTALL_ROOT}/etc/alx_version
682 KRNVER="ALX-${ALXVER}"
683 ALXVER="${OLD_ALXVER}"
684 fi
685
686 [[ -z ${KRNVER} ]] && KRNVER="AutoSta_LX"
687 [[ -z ${KRNINITRD} ]] && KRNINITRD="initrd"
688 [[ -z ${KRNIMG} ]] && KRNIMG="vmlinuz"
689
690 # uuid support
691 if is_uuid_supported
692 then
693 my_roothdd="UUID=$(get_uuid ${ROOTHDD})"
694 else
695 my_roothdd="${ROOTHDD}"
696 fi
697
698 CONFIG="${grubconf}"
699 clearconfig
700 addconfig "default 0"
701 addconfig "timeout 3"
702 # using current root password
703 addconfig "password --md5 $(cat ${INSTALL_ROOT}/etc/shadow | grep root | cut -d: -f2)"
704 addconfig
705 addconfig "# normal boot"
706 addconfig "title ${KRNVER}"
707 addconfig "root (hd0,0)"
708 addconfig "kernel /boot/${KRNIMG} root=${my_roothdd} ${KERNELOPTS} ${GRUBLEGACYOPTS}"
709 if is_initrd_supported
710 then
711 addconfig "initrd /boot/${KRNINITRD}"
712 fi
713 addconfig
714 addconfig "# admin boot"
715 addconfig "title ${KRNVER} - Re-run hardware-detection"
716 addconfig "lock"
717 addconfig "root (hd0,0)"
718 addconfig "kernel /boot/${KRNIMG} root=${my_roothdd} ${KERNELOPTS} ${GRUBLEGACYOPTS} hardware-auto-detection"
719 if is_initrd_supported
720 then
721 addconfig "initrd /boot/${KRNINITRD}"
722 fi
723 addconfig
724 addconfig "title ${KRNVER} - Reset *all* local settings"
725 addconfig "lock"
726 addconfig "root (hd0,0)"
727 addconfig "kernel /boot/${KRNIMG} root=${my_roothdd} ${KERNELOPTS} ${GRUBLEGACYOPTS} alx-reset-settings"
728 if is_initrd_supported
729 then
730 addconfig "initrd /boot/${KRNINITRD}"
731 fi
732
733 # write bootsector chrooted (lfs/magellan)
734 CONFIG=${INSTALL_ROOT}/.installrc
735 clearconfig
736 addconfig '/usr/sbin/grub --no-floppy --batch << "EOF" 1> /dev/null 2> /dev/null'
737 addconfig 'root (hd0,0)'
738 addconfig 'setup (hd0)'
739 addconfig 'quit'
740 addconfig 'EOF'
741 addconfig 'exit 0'
742 fi
743
744 ## enter chroot
745 enter_chroot_installrc
746 }
747
748 is_initrd_supported()
749 {
750 # only generate initrds if the cmd exists
751 [[ -x ${INSTALL_ROOT}/sbin/mkinitrd ]] && return 0
752 return 1
753 }
754
755 install_initrd_chroot()
756 {
757 local CONFIG
758
759 # only generate initrds if the cmd exists
760 is_initrd_supported || return 0
761
762 FSMODS="${FORMAT_FILESYSTEM}"
763 DISKMODS="sd_mod"
764 OLDPATAMODS="amd74xx piix sis5513 via82cxxx"
765 PATAMODS="ata_piix pata_amd pata_mpiix pata_oldpiix pata_sis pata_via"
766 SATAMODS="sata_via sata_sis sata_nv"
767 DRMMODS="i915 mga nouveau r128 radeon savage sis tdfx ttm via"
768 OTHERMODS=""
769 case ${SPECIALDEVICE} in
770 zotac_intel|i845) FBMODS=""; DRMMODS="i915" ;;
771 zotac_nvidia) FBMODS=""; DRMMODS="nouveau" ;;
772 rangee) FBMODS="" ;; ## fallback to vesafb, viafb does not run on all CLE266 boards
773 # not working with kms enabled drivers -> segfaults
774 #maxdata) FBMODS="i810fb" ;; ## check for maxdata / i810/ i815 Chipsets and disable KMS and use i810fb frambuffer
775 maxdata) FBMODS="" ;;
776 *) FBMODS="uvesafb" ;;
777 esac
778
779 # add a filesystems recoqnized by the bootloader if the current ${FORMAT_FILESYSTEM} is not supported
780 case "${FORMAT_FILESYSTEM}" in
781 f2fs) FSMODS+=" ext2" ;;
782 esac
783
784 if [[ ${FORMFACTOR} = laptop ]]
785 then
786 OTHERMODS="acpi-cpufreq cpufreq_ondemand cpufreq_conservative cpufreq_powersave"
787 fi
788
789 # install an appropriate uvesafb.conf
790 CONFIG=${INSTALL_ROOT}/etc/modprobe.d/uvesafb.conf
791 clearconfig
792 addconfig "options uvesafb mode_option=1024x768-32@60 scroll=ywrap"
793
794 # install an appropriate viafb.conf
795 CONFIG=${INSTALL_ROOT}/etc/modprobe.d/viafb.conf
796 clearconfig
797 addconfig "options viafb viafb_mode=1024x768 viafb_refresh=60"
798
799 # install an appropriate i810fb.conf
800 CONFIG=${INSTALL_ROOT}/etc/modprobe.d/i810fb.conf
801 clearconfig
802 addconfig "options i810fb xres=1024 yres=768 bpp=16 mtrr=1 hsync1=30 hsync2=62 vsync1=30 vsync2=60"
803
804 CONFIG=${INSTALL_ROOT}/.installrc
805 clearconfig
806 addconfig 'echo "MODULES=\"${FSMODS} ${DISKMODS} ${OLDATAMODS} ${PATAMODS} ${SATAMODS} ${DRMMODS} ${FBMODS} ${OTHERMODS}\"" > /etc/conf.d/mkinitrd'
807 addconfig 'mkinitrd -f /boot/$(readlink /boot/initrd) $(readlink /boot/vmlinuz | sed "s:kernel-::g") > /dev/null'
808 addconfig 'exit 0'
809 ## enter chroot
810 enter_chroot_installrc
811 }
812
813 is_uuid_supported()
814 {
815 # f2fs needs special treatments as the old busybox does not support this fs
816 # use the blkid from util-linux instead of busybox
817 if [[ ${FORMAT_FILESYSTEM} = f2fs ]]
818 then
819 if [[ -x $(which blkid &> /dev/null) ]]
820 then
821 return 0
822 fi
823 else
824 if [[ -x $(which busybox.mkinitrd &> /dev/null) ]]
825 then
826 # only detect uuids if supported
827 if [[ ! -z $(busybox.mkinitrd | grep blkid) ]]
828 then
829 return 0
830 fi
831 fi
832 fi
833
834 return 1
835 }
836
837 get_uuid()
838 {
839 local UUID
840 local SEC_TYPE
841 local TYPE
842 local blkidcmd
843
844 local dev="$1"
845 [[ -z ${dev} ]] && die "no dev given"
846
847 # check if given device is already an UUID
848 if [[ ${dev/UUID=/}x != ${dev}x ]]
849 then
850 eval "${dev}"
851 else
852 # f2fs needs special treatments as the old busybox does not support this fs
853 # use the blkid from util-linux instead of busybox
854 if [[ ${FORMAT_FILESYSTEM} = f2fs ]]
855 then
856 blkidcmd="blkid"
857 else
858 blkidcmd="busybox.mkinitrd blkid"
859 fi
860 eval $(${blkidcmd} ${dev} | grep "${dev}:" | sed 's/.*:\ //')
861 fi
862 echo "${UUID}"
863 }
864
865 install_system_settings()
866 {
867 # schreibe fstab
868 if is_uuid_supported
869 then
870 if [[ -n ${BOOTHDD} ]]
871 then
872 echo -e "UUID=$(get_uuid ${BOOTHDD})\t/boot\t${FORMAT_FILESYSTEM}\tnoatime,noauto\t1 1" > ${INSTALL_ROOT}/etc/fstab || die
873 fi
874 if [[ -n ${ROOTHDD} ]]
875 then
876 echo -e "UUID=$(get_uuid ${ROOTHDD})\t/\t${FORMAT_FILESYSTEM}\tnoatime\t0 0" >> ${INSTALL_ROOT}/etc/fstab || die
877 fi
878 else
879 if [[ -n ${BOOTHDD} ]]
880 then
881 echo -e "${BOOTHDD}\t/boot\t${FORMAT_FILESYSTEM}\tnoatime,noauto\t1 1" > ${INSTALL_ROOT}/etc/fstab || die
882 fi
883 if [[ -n ${ROOTHDD} ]]
884 then
885 echo -e "${ROOTHDD}\t/\t${FORMAT_FILESYSTEM}\tnoatime\t0 0" >> ${INSTALL_ROOT}/etc/fstab || die
886 fi
887 fi
888 # not needed busybox loads all with swapon -a, even if not mentioned in fstab
889 #echo -e "UUID='$(get_uuid ${SWAPHDD})'\tswap\tswap\tpri=1\t0 0" >> ${INSTALL_ROOT}/etc/fstab || die
890 echo -e "proc\t/proc\tproc\tdefaults\t0 0" >> ${INSTALL_ROOT}/etc/fstab || die
891 echo -e "shm\t/dev/shm\ttmpfs\tdefaults\t0 0" >> ${INSTALL_ROOT}/etc/fstab || die
892
893 # install network config skeleton
894 install -m0644 ${INSTALL_ROOT}/etc/alxconfig-ng/skel/net/net.eth0 ${INSTALL_ROOT}/etc/conf.d/ || die
895
896 # intel framebufer quirk
897 if [[ -e /proc/fb ]]
898 then
899 if [[ ! -z $(grep 'inteldrmfb' /proc/fb) ]]
900 then
901 fbdev=$(grep 'inteldrmfb' /proc/fb | sed 's:\([0-9]\).*:\1:')
902 if [[ ${fbdev} != 0 ]]
903 then
904 sed -i "s:^\(SPLASH_DEV=\).*:\1\"/dev/fb${fbdev}\":" ${INSTALL_ROOT}/etc/splash/splash.conf || die
905 fi
906 fi
907 fi
908 }
909
910 install_umount_rootfs()
911 {
912 cd /
913 if [[ -n ${BOOTHDD} ]]
914 then
915 umount ${INSTALL_ROOT}/boot || die
916 fi
917 if [[ -n ${ROOTHDD} ]]
918 then
919 umount ${INSTALL_ROOT} || die
920 fi
921 if [[ -n ${SWAPHDD} ]]
922 then
923 swapoff ${SWAPHDD} || die
924 fi
925 }
926
927 install_do_reboot()
928 {
929 reboot
930 }
931
932 #################################################
933 # Install Main Scripts #
934 #################################################
935
936 run_install()
937 {
938 local method="$1"
939
940 # setup install environment
941 export KERNELOPTS="${DEFAULT_KERNELOPTS}"
942 export GRUBLEGACYOPTS="${GRUBLEGACYOPTS}"
943 export GRUB2OPTS="${GRUB2OPTS}"
944 export GRUB2GFXPAYLOAD="${DEFAULT_GRUB2GFXPAYLOAD}"
945 export FORMFACTOR="${DEFAULT_FORMFACTOR}"
946 export FORMAT_FILESYSTEM="${DEFAULT_FORMAT_FILESYSTEM}"
947
948 case "${method}" in
949 auto)
950 export INSTALL_METHOD="${method}"
951 ;;
952 normal)
953 export INSTALL_METHOD="${method}"
954 ;;
955 single)
956 export INSTALL_METHOD="${method}"
957 ;;
958 flash)
959 export FORMAT_FILESYSTEM="f2fs"
960 export INSTALL_METHOD="${method}"
961 ;;
962 *)
963 echo "Unknown install method '${method}', aborting."
964 exit 1
965 ;;
966 esac
967
968 dialog_hardware_detection
969
970 dialog_setup_hdd_partitions
971 dialog_setup_hdd_format
972 setup_hdd_format > /dev/null
973 install_mount_rootfs
974 (install_system_image > /tmp/install.log) 2> /tmp/install_errors.log | dialog_install_meter | dialog_install_system_image
975
976 dialog_install_settings
977 sleep 1
978 install_system_settings
979 install_initrd_chroot
980
981 dialog_install_bootsector
982 install_bootsector_chroot
983
984 install_umount_rootfs
985 dialog_install_successful
986 }
987
988 # set some proper traps
989 trap "trap_exit" SIGINT SIGQUIT
990
991 dialog_main
992
993 exit 0